# Licenses
- BambooTracker - GPL v2+

## Libraries
- [adpcm](https://github.com/superctr/adpcm) by Ian Karlsson (superctr) - Public domain
  - BambooTracker/chip/codec/*
- [C86CTL](https://github.com/honet/c86ctl) by honet - [BSD 3-Clause](./c86ctl_lisence.txt)
  - BambooTracker/chip/c86ctl/*
- [emu2149](https://github.com/digital-sound-antiques/emu2149) by Mitsutaka Okazaki - MIT
  - BambooTracker/chip/emu2149/*
- fmopn by Tatsuyuki Satoh, Jarek Burczynski and ValleyBell - GPL v2+
  - BambooTracker/chip/mame/fmopn.*
  - BambooTracker/chip/mame/fmopn_2608rom.h
- [libOPNMIDI](https://github.com/Wohlstand/libOPNMIDI) by Vitaly Novichkov (Wohlstand) - MIT
  - BambooTracker/format/wopn_file.*
- Nuked OPN-MOD (added OPNA functionality to [Nuked-OPN2](https://github.com/nukeykt/Nuked-OPN2) by Alexey Khokholov (Nuke.YKT)) by Jean Pierre Cimalando - LGPL v2.1 or later
  - BambooTracker/chip/nuked/ym3438.*
- [Qt](https://www.qt.io/) - GPL v2+ or LGPL v3
- [RtAudio](http://www.music.mcgill.ca/~gary/rtaudio/) by Gary P. Scavone - [rtaudio_license.txt](./rtaudio_license.txt)
  - submodules/RtAudio/src/*
- [RtMidi](https://github.com/Wohlstand/rtmidi) by Gary P. Scavone - [rtmidi_license.txt](./rtmidi_license.txt)
  - submodules/RtMidi/src/*
- [SCCI](http://www.pyonpyon.jp/~gasshi/fm/scci.html) by がし３ (gasshi) - [scci_license.txt](./scci_license.txt)
  - BambooTracker/chip/scci/*
- [Silk icons](http://www.famfamfam.com/lab/icons/silk/) by Mark James - CC BY 2.5 or 3.0
  - BambooTracker/resources/icon/if_*.png
  - BambooTracker/resources/icon/iconfinder_*.png
- ymdeltat by Tatsuyuki Satoh, Jarek Burczynski and ValleyBell - GPL v2+
  - BambooTracker/chip/mame/ymdeltat.*

## Other parts
- MIT license
  - BambooTracker/*.{hpp,cpp}
  - BambooTracker/audio/*.{hpp,cpp}
  - BambooTracker/chip/*.{hpp,h,cpp}
  - BambooTracker/chip/mame/mame_2608.*
  - BambooTracker/chip/mame/nuked_2608.*
  - BambooTracker/command/*
  - BambooTracker/gui/*
  - BambooTracker/instrument/*
  - BambooTracker/io/*
  - BambooTracker/midi/*.{hpp,cpp}
  - BambooTracker/module/*
- BSD 3-Clause
  - BambooTracker/chip/mame/mamedef.h
